#ifndef _MSPUTIL_H
#define _MSPUTIL_H
#include <linux/videodev.h>
#include <linux/i2c.h>

typedef enum {WPH_UNSET,WPH_DSP=0x01, WPH_DEM=0x02} DEV;


int snprintf(char*p,int size, char *fmt,...);

int msp3400c_reset(struct i2c_client *client);


int			
msp3400c_read(struct i2c_client *client, int dev, int addr);



int			
msp3400c_write(struct i2c_client *client, int dev, int addr, int val);


#define MSP_DSP_LAST_REG 0x0041
#define MSP_DSP_NUMREG (MSP_DSP_LAST_REG+1)

#if 0
typedef struct 
{ 
  char dsp_valid[MSP_DSP_NUMREG];
  unsigned short dsp_reg[MSP_DSP_NUMREG];
} msp_shadow;

#else
typedef struct 
{ 
  struct { unsigned int valid : 1; 
    unsigned int lock : 4;	/* each bit corresponds with 4 register bits;
				   if the lock bit is 1, the corresponding 
				   1/2 byte of the register will 
				   not be written*/
  } dsp_flags[MSP_DSP_NUMREG];
  short dsp_reg[MSP_DSP_NUMREG];
} msp_shadow;

#endif



#define HIGH 0xff00
#define LOW 0x00ff
void dump_shadow(msp_shadow *s);

int  wph_mspset(struct i2c_client *client,int addr,int dev,int val,int mask,msp_shadow*s);
int  wph_mspget(struct i2c_client *client,int addr,int dev,int *val,int mask,msp_shadow*s);
int  wph_mspget_shadow(struct i2c_client *client,int addr,int dev,int *val,int mask,msp_shadow*s);


#if 0
int  wph_mspset_shadowonly(struct i2c_client *client,int addr,int
			   dev,int val,int mask,msp_shadow *s);
#endif

int  wph_msplockandset(struct i2c_client *client,int addr,int
		       dev,int val,int mask,msp_shadow *s);
int  wph_mspunlock(struct i2c_client *client,int addr,int
		   dev,int mask,msp_shadow *s);




#endif

/*
 * Local variables:
 *  compile-command: "sudo make &&sudo make install && sudo depmod -a"
 * End:
 */
